<?php
//define("BE_CONSOLE",1);

use Illuminate\Database\Capsule\Manager as Capsule;
header("Access-Control-Allow-Origin: *");
if(!defined("WHMCS")) {
    die("WHMCS Kurulu Değil");
}
set_time_limit(0);
ini_set("display_errors",0);

use Whmcs\Misc;
use WHMCS\Menu;

function diyovm_MetaData(){
    return [
        "DisplayName" => "DiyoVM",
        "APIVersion" => "1.1",
        "RequiresServer" => true,
        "DefaultNonSSLPort" => "80",
        "DefaultSSLPort" => "80",
        "ServiceSingleSignOnLabel" => "Panele Giriş Yap",
        "AdminSingleSignOnLabel" => "Panele Admin Olarak Giriş Yap",
    ];
}
function diyovm_ConfigOptions(){
    $data = [
        "Cluster ID" => [
            "Description"       => "<br>DiyoVM sistemindeki cluster değerini girdiğiniz sunucuya kurulur",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => "",
        ],
        "Host ID" => [
            "Description"       => "<br>DiyoVM sistemindeki host değerini girdiğiniz sunucuya kurulur",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => ""
        ],
        "Havuz ID" => [
            "Description"       => "<br>DiyoVM sistemindeki havuz değerini girdiğini havuzu kullanır",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => ""
        ],
        "Disk ID" => [
            "Description"       => "<br>DiyoVM sistemindeki kaynak değerini girdiğini diski kullanır",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => ""
        ],
        "Plan Paketi" => [
            "Description"       => "<br>DiyoVM sistemindeki paketi girerek direkt kullanın",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => ""
        ],
        "Format Hakkı" => [
            "Description"       => "<br>Belirtilen süre içerisinde kaç adet format atabiliceğini belirler(Boş bırakırsanız sınırsız).",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => "3"
        ],
        "IP Adresi(Adet)" => [
            "Description"       => "<br>Sunucunun kullanacağı ip adresi adetini seçin",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => ""
        ],
        "IP Adresi Paketi" => [
            "Description"       => "<br>DiyoVM sistemindeki ip adresi girerek direkt kullanın",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => ""
        ],
        "CPU Sayısı(Adet)" => [
            "Description"       => "<br>Sunucunun işlemcinizde kullanacağı çekirdek sayısını belirtin",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => ""
        ],
        "Soket Başına CPU Sayısı" => [
            "Description"       => "<br>Sunucunuzda 1'den fazla işlemci var ise olacak dağılımı belirtin",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => "1"
        ],
        "CPU Limiti(Mhz)" => [
            "Description"       => "<br>Sunucunun işlemcinizde kullanabiliceği maksimum limiti belirleyin, boş bırakırsanız kullanılmaz",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => ""
        ],
        "Ram Miktarı(GB)" => [
            "Description"       => "<br>Sunucunun sahip olacağı ram miktarını belirtin",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => ""
        ],
        "Disk Miktarı(GB)" => [
            "Description"       => "<br>Sunucunun sahip olacağı disk miktarını belirtin",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => ""
        ],
        "Bant Genişliği(GB)" => [
            "Description"       => "<br>Sunucunun sahip olacağı bant genişliği miktarını belirtin",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => ""
        ],
        "Yedek Hakkı" => [
            "Description"       => "<br>Sunucunun alabiliceği yedek hakkını belirleyin (Olmaması İçin 0)",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => "0"
        ],
        "Format Şablon Listesi" => [
            "Description"       => "<br>Eğer özel olarak sadece belirli şablonları kullanarak format atılmasını istiyorsanız bu kısma girin",
            "Type"              => "text",
            "Size"              => "100",
            "Default"           => "5,7"
        ]
    ];
    $product = Capsule::table("tblproducts")->where("id",$_POST["id"])->first();
    if($product){
        $productconfigs = Capsule::table("tblproductconfiglinks")->select("gid")->where("pid",$product->id)->get();
        $list = [];
        foreach($productconfigs as $config){
            $list[] = $config->gid;
        }
        $productconfigoptions = Capsule::table("tblproductconfigoptions")->whereIn("gid",$list)->get();
        $productoptions = [];
        if($productconfigoptions){
            $productoptions[0] = "Seçilmedi!";
            foreach($productconfigoptions as $config){
                $productoptions[$config->id] = $config->optionname;
            }
            $data["İşletim Sistemi Grubunu Seçin"] = ["Type" => "dropdown","Options" => $productoptions,"Description" => "İşletim sistemi ile alakalı bölümü seçiniz"];
            $data["Cpu Grubunu Seçin"] = ["Type" => "dropdown","Options" => $productoptions,"Description" => "Cpu ile alakalı bölümü seçiniz"];
            $data["Ram Grubunu Seçin"] = ["Type" => "dropdown","Options" => $productoptions,"Description" => "Ram ile alakalı bölümü seçiniz"];
            $data["Disk Grubunu Seçin"] = ["Type" => "dropdown","Options" => $productoptions,"Description" => "Disk ile alakalı bölümü seçiniz"];
            $data["IP Adresi Grubunu Seçin"] = ["Type" => "dropdown","Options" => $productoptions,"Description" => "IP Adresi ile alakalı bölümü seçiniz"];
            $data["Bant Genişliği Grubunu Seçin"] = ["Type" => "dropdown","Options" => $productoptions,"Description" => "Bant genişliği ile alakalı bölümü seçiniz"];
            $data["Yedek Hakkı Grubunu Seçin"] = ["Type" => "dropdown","Options" => $productoptions,"Description" => "Yedek hakkı ile alakalı bölümü seçiniz"];
        }
    }
    return $data;
}
function diyovm_TestConnection($params){
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $response = $api->beTestConnection([
        "address" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    if(!$response["status"]){
        logModuleCall("diyovm",__FUNCTION__,$params,$response["message"],"");
        return ["success" => false,"error" => $response["message"]];
    }
    return ["success" => true,"error" => ""];
}
function diyovm_CreateAccount($params){
    if($params["customfields"]["vm_id"]){
        return "Bu sunucu daha önceden kurulmuş gözüküyor lütfen baştan kurulum için(vm_id) kısmını siliniz!";
    }
    return diyovm_beCreateServer($params);
}
function diyovm_ChangePackage($params){
    $newoptions = $params["model"]["product"];
    if($newoptions["servertype"] == "diyovm"){
        $basic_vals = [
            "vm_id" => $params["customfields"]["vm_id"],
            "clusterId" => (int)$newoptions["configoption1"],
            "hostId" => (int)$newoptions["configoption2"],
            "poolId" => (int)$newoptions["configoption3"],
            "datastoreId" => (int)$newoptions["configoption4"],
            "planId" => (int)$newoptions["configoption5"],
            "cpuCore" => (int)$newoptions["configoption9"],
            "cpuPerCount" => (int)$newoptions["configoption10"],
            "cpuLimitMhz" => (int)$newoptions["configoption11"],
            "ramGB" => (int)$newoptions["configoption12"],
            "diskGB" => (int)$newoptions["configoption13"],
            "bandwithGB" => (int)$newoptions["configoption14"],
            "oldPlanId" => (int)$params["configoption5"]
        ];
        if(!class_exists("beDiyoApi")){
            require __DIR__."/be_system.php";
        }
        $api = new beDiyoApi();
        $api->beSetServer([
            "name" => $params["serverhostname"],
            "username" => $params["serverusername"],
            "password" => $params["serverpassword"],
            "access_hash" => $params["serveraccesshash"]
        ]);
        $response = $api->beUpdateVM($basic_vals);
        if(!$response["status"]){
            logModuleCall("diyovm",__FUNCTION__,$params,$response["message"],"");
            return $response["message"];
        }
    }
    return "success";
}
function diyovm_beCreateServer($params,$customIP = ""){
    $basic_vals = [
        "clusterId" => (int)$params["configoption1"],
        "hostId" => (int)$params["configoption2"],
        "poolId" => (int)$params["configoption3"],
        "datastoreId" => (int)$params["configoption4"],
        "planId" => (int)$params["configoption5"],
        "ipCount" => (int)$params["configoption7"],
        "ipPlanId" => (int)$params["configoption8"],
        "cpuCore" => (int)$params["configoption9"],
        "cpuPerCount" => (int)$params["configoption10"],
        "cpuLimitMhz" => (int)$params["configoption11"],
        "ramGB" => (int)$params["configoption12"],
        "diskGB" => (int)$params["configoption13"],
        "bandwithGB" => (int)$params["configoption14"],
        "snapShotCount" => (int)$params["configoption15"],
        "userMail" => $params["clientsdetails"]["email"]
    ];
    $findgroups[(int)$params["configoption17"]] = "osId";
    if((int)$params["configoption18"]){
        $findgroups[(int)$params["configoption18"]] = "cpuCoreExtra";
    }
    if((int)$params["configoption19"]){
        $findgroups[(int)$params["configoption19"]] = "ramGBExtra";
    }
    if((int)$params["configoption20"]){
        $findgroups[(int)$params["configoption20"]] = "diskGBExtra";
    }
    if((int)$params["configoption21"]){
        $findgroups[(int)$params["configoption21"]] = "ipCountExtra";
    }
    if((int)$params["configoption22"]){
        $findgroups[(int)$params["configoption22"]] = "bandwithGBExtra";
    }
    if((int)$params["configoption23"]){
        $findgroups[(int)$params["configoption23"]] = "snapShotCountExtra";
    }
    if(empty($findgroups[(int)$params["configoption17"]])){
        return "Ürün yapılandırmasında işletim sistemi seçilmedi lütfen yönetici ile iletişime geçin!";
    }
    $productconfigoptions = Capsule::table("tblproductconfigoptions")->select("id","optionname")->whereIn("id",array_keys($findgroups))->get();
    foreach($productconfigoptions as $config){
        $basic_vals[$findgroups[$config->id]] = $params["configoptions"][$config->optionname];
    }
    $basic_vals["userPassword"] = $params["password"];
    if($customIP){
        $basic_vals["ipCustom"] = $customIP;
    }
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beCreateVM($basic_vals);
    if(!$response["status"]){
        logModuleCall("diyovm",__FUNCTION__,$params,$response["message"],"");
        return $response["message"];
    }
    $serviceid = (int)$params["serviceid"];
    $params["model"]->serviceProperties->save([
        "vm_id" => $response["sid"],
        "taskid" => $response["tid"],
        "status" => "1",
        "password" => $response["password"]
    ]);
    Capsule::table("tblhosting")->where("id","=",$serviceid)->update([
        "domain" => $response["hostname"],
        "username" => $response["username"],
        "dedicatedip" => $response["iplist"][0],
        "password" => encrypt($response["password"]),
        "assignedips" => implode(PHP_EOL,$response["iplist"])
    ]);
    return "success";
}
function diyovm_SuspendAccount($params){
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beSuspend([
        "vm_id" => $params["customfields"]["vm_id"],
        "action" => "suspend"
    ]);
    if(!$response["status"]){
        return $response["message"];
    }
    $params["model"]->serviceProperties->save(["status" => "-1"]);
    return true;
}
function diyovm_UnSuspendAccount($params){
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beSuspend([
        "vm_id" => $params["customfields"]["vm_id"],
        "action" => "unsuspend"
    ]);
    if(!$response["status"]){
        return $response["message"];
    }
    $params["model"]->serviceProperties->save(["status" => "2"]);
    return true;
}
function diyovm_TerminateAccount($params){
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beDeleteVM([
        "vm_id" => $params["customfields"]["vm_id"]
    ]);
    if(!$response["status"]){
        return $response["message"];
    }
    return true;
}
function diyovm_start($params){
    if($params["customfields"]["status"] != 2){
        return "Ürün kullanım için hazır değil!";
    }
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beStatusAction([
        "vm_id" => $params["customfields"]["vm_id"],
        "action" => "start"
    ]);
    if(!$response["status"]){
        return $response["message"];
    }
    return true;
}
function diyovm_stop($params){
    if($params["customfields"]["status"] != 2){
        return "Ürün kullanım için hazır değil!";
    }
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beStatusAction([
        "vm_id" => $params["customfields"]["vm_id"],
        "action" => "stop"
    ]);
    if(!$response["status"]){
        return $response["message"];
    }
    return true;
}
function diyovm_restart($params){
    if($params["customfields"]["status"] != 2){
        return "Ürün kullanım için hazır değil!";
    }
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beStatusAction([
        "vm_id" => $params["customfields"]["vm_id"],
        "action" => "restart"
    ]);
    if(!$response["status"]){
        return $response["message"];
    }
    return true;
}
function diyovm_ClientAreaCustomButtonArray($params){
    return [];
}
function diyovm_power_action($params){
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beStatusAction([
        "vm_id" => $params["customfields"]["vm_id"],
        "action" => $_POST["process"]
    ]);
    $response["refresh"] = true;
    echo json_encode($response,JSON_UNESCAPED_UNICODE);
    exit;
}
function diyovm_entegration($params){
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $type = $_POST["type"];
    switch($type){
        case "network" : 
            $response = $api->beEntegrationNetwork([
                "vm_id" => $params["customfields"]["vm_id"]
            ]);
            break;
        case "disc" :
            $response = $api->beEntegrationDisc([
                "vm_id" => $params["customfields"]["vm_id"]
            ]);
            break;
        default:
            echo json_encode(["status" => false,"message" => "Belirtilen işlem bulunamadı!"]);
    }
    echo json_encode($response,JSON_UNESCAPED_UNICODE);
    exit;
}
function diyovm_menu($params){
    return "success";
}
function diyovm_menu_password($params){
    $serviceid = (int)$params["serviceid"];
    $lang = $params["clientsdetails"]["language"];
    if(!$lang){
        $lang = "turkish";
    }
    if(!file_exists(__DIR__."/lang/".$lang.".php")){
        $lang = "turkish";
    }
    $lang = include(__DIR__."/lang/".$lang.".php");
    return [
        "tabOverviewReplacementTemplate" => "templates/password.tpl",
        "vars" => [
            "lang" => $lang,
            "default_url" => $params["default_url"],
            "serviceid" => $serviceid
        ]
    ];
}
function diyovm_password_change($params){
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->bePasswordVM([
        "vm_id" => $params["customfields"]["vm_id"],
        "onserver" => true,
        "password" => $_POST["password"]
    ]);
    echo json_encode($response,JSON_UNESCAPED_UNICODE);
    exit;
}
function diyovm_menu_console($params){
    if(!defined("BE_CONSOLE")){
        beError("Eksiklik","Belirtilen firma üzerinde DiyoVM Konsol modülü bulunmamaktadır. Bu yüzden konsola erişemezsiniz!");
    }
    $serviceid = (int)$params["serviceid"];
    $serviceid = (int)$params["serviceid"];
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beGetVmConsole([
        "vm_id" => $params["customfields"]["vm_id"]
    ]);
    if(!$response["status"]){
        echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
        exit;
    }
    $lang = $params["clientsdetails"]["language"];
    if(!$lang){
        $lang = "turkish";
    }
    if(!file_exists(__DIR__."/lang/".$lang.".php")){
        $lang = "turkish";
    }
    $lang = include(__DIR__."/lang/".$lang.".php");
    return [
        "tabOverviewReplacementTemplate" => "templates/console.tpl",
        "vars" => [
            "lang" => $lang,
            "default_url" => $params["default_url"],
            "console_url" => $response["url"],
            "serviceid" => $serviceid
        ]
    ];
}
function diyovm_menu_ip($params){
    $serviceid = (int)$params["serviceid"];
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beGetVm([
        "vm_id" => $params["customfields"]["vm_id"],
        "iplist" => true,
    ]);
    if(!$response["status"]){
        echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
        exit;
    }
    $lang = $params["clientsdetails"]["language"];
    if(!$lang){
        $lang = "turkish";
    }
    if(!file_exists(__DIR__."/lang/".$lang.".php")){
        $lang = "turkish";
    }
    $lang = include(__DIR__."/lang/".$lang.".php");
    return [
        "tabOverviewReplacementTemplate" => "templates/ip.tpl",
        "vars" => [
            "lang" => $lang,
            "default_url" => $params["default_url"],
            "iplist" => $response["iplist"],
            "serviceid" => $serviceid
        ]
    ];
}
function diyovm_menu_rdns($params){
    $serviceid = (int)$params["serviceid"];
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beGetVm([
        "vm_id" => $params["customfields"]["vm_id"],
        "iplist" => true,
        "rdnslist" => true,
    ]);
    if(!$response["status"]){
        echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
        exit;
    }
    $rdnsstatuslist = [
        -1 => [
            "name" => "Reddedildi",
            "color" => "btn-danger"
        ],
        1 => [
            "name" => "İşlemde",
            "color" => "btn-primary"
        ],
        2 => [
            "name" => "Aktif",
            "color" => "btn-success"
        ]
    ];
    $lang = $params["clientsdetails"]["language"];
    if(!$lang){
        $lang = "turkish";
    }
    if(!file_exists(__DIR__."/lang/".$lang.".php")){
        $lang = "turkish";
    }
    $lang = include(__DIR__."/lang/".$lang.".php");
    return [
        "tabOverviewReplacementTemplate" => "templates/rdns.tpl",
        "vars" => [
            "lang" => $lang,
            "default_url" => $params["default_url"],
            "iplist" => $response["iplist"],
            "rdnslist" => $response["rdnslist"],
            "rdnsstatuslist" => $rdnsstatuslist,
            "serviceid" => $serviceid
        ]
    ];
}
function diyovm_menu_rdns_create($params){
    $serviceid = (int)$params["serviceid"];
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beGetVm([
        "vm_id" => $params["customfields"]["vm_id"],
        "iplist" => true,
    ]);
    if(!$response["status"]){
        echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
        exit;
    }
    $lang = $params["clientsdetails"]["language"];
    if(!$lang){
        $lang = "turkish";
    }
    if(!file_exists(__DIR__."/lang/".$lang.".php")){
        $lang = "turkish";
    }
    $lang = include(__DIR__."/lang/".$lang.".php");
    return [
        "tabOverviewReplacementTemplate" => "templates/rdnscreate.tpl",
        "vars" => [
            "lang" => $lang,
            "default_url" => $params["default_url"],
            "iplist" => $response["iplist"],
            "serviceid" => $serviceid
        ]
    ];
}
function diyovm_menu_rdns_edit($params){
    $rid = (int)$_GET["rid"];
    $serviceid = (int)$params["serviceid"];
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beGetVm([
        "vm_id" => $params["customfields"]["vm_id"],
        "iplist" => true,
        "rdnslist" => true,
    ]);
    if(!$response["status"]){
        echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
        exit;
    }
    $rdns = [];
    foreach($response["rdnslist"] as $rdnslist){
        if($rdnslist["rid"] == $rid){
            $rdns = $rdnslist;
            break;
        }
    }
    if(!$rdns){
        beError("Bulunamadı","Belirtilen rDNS kaydı sistem üzerinde bulunamadı!");
    }
    $lang = $params["clientsdetails"]["language"];
    if(!$lang){
        $lang = "turkish";
    }
    if(!file_exists(__DIR__."/lang/".$lang.".php")){
        $lang = "turkish";
    }
    $lang = include(__DIR__."/lang/".$lang.".php");
    return [
        "tabOverviewReplacementTemplate" => "templates/rdnsedit.tpl",
        "vars" => [
            "lang" => $lang,
            "default_url" => $params["default_url"],
            "iplist" => $response["iplist"],
            "rdns" => $rdns,
            "serviceid" => $serviceid
        ]
    ];
}
function diyovm_rdns_create($params){
    $serviceid = (int)$params["serviceid"];
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beCreateDnsRecord([
        "vm_id" => $params["customfields"]["vm_id"],
        "iid" => (int)$_POST["iid"],
        "type" => $_POST["type"],
        "dns" => $_POST["dns"],
        "priority" => (int)$_POST["priority"],
        "ttl" => (int)$_POST["ttl"],
    ]);
    $response["url"] = "clientarea.php?action=productdetails&id=".$serviceid."&bemenu=rdns";
    echo json_encode($response,JSON_UNESCAPED_UNICODE);
    exit;
}
function diyovm_rdns_edit($params){
    $serviceid = (int)$params["serviceid"];
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beEditDnsRecord([
        "vm_id" => $params["customfields"]["vm_id"],
        "rid" => (int)$_POST["rid"],
        "iid" => (int)$_POST["iid"],
        "type" => $_POST["type"],
        "dns" => $_POST["dns"],
        "priority" => (int)$_POST["priority"],
        "ttl" => (int)$_POST["ttl"],
    ]);
    $response["url"] = "clientarea.php?action=productdetails&id=".$serviceid."&bemenu=rdns";
    echo json_encode($response,JSON_UNESCAPED_UNICODE);
    exit;
}
function diyovm_rdns_delete($params){
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beDeleteDnsRecord([
        "vm_id" => $params["customfields"]["vm_id"],
        "rid" => (int)$_POST["rid"]
    ]);
    $response["refresh"] = 1;
    echo json_encode($response,JSON_UNESCAPED_UNICODE);
    exit;
}
function diyovm_menu_snapshot($params){
    $serviceid = (int)$params["serviceid"];
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beGetVm([
        "vm_id" => $params["customfields"]["vm_id"],
        "snapshotlist" => true,
    ]);
    if(!$response["status"]){
        echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
        exit;
    }
    $lang = $params["clientsdetails"]["language"];
    if(!$lang){
        $lang = "turkish";
    }
    if(!file_exists(__DIR__."/lang/".$lang.".php")){
        $lang = "turkish";
    }
    $lang = include(__DIR__."/lang/".$lang.".php");
    return [
        "tabOverviewReplacementTemplate" => "templates/snapshot.tpl",
        "vars" => [
            "lang" => $lang,
            "default_url" => $params["default_url"],
            "snapshotlist" => $response["snapshotlist"],
            "serviceid" => $serviceid
        ]
    ];
}
function diyovm_snapshot_create($params){
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $snapcount = (int)$params["configoption15"];
    if((int)$params["configoption23"]){
        $productconfigoptions = Capsule::table("tblproductconfigoptions")->select("id","optionname")->where("id",array_keys([$params["configoption23"]]))->get();
        foreach($productconfigoptions as $config){
            $snapcount += (int)$params["configoptions"][$config->optionname];
        }
    }
    if($snapcount == 0){
        echo json_encode(["status" => false,"message" => "Bu siparişte hiç yedek alma hakkınız bulunmuyor!"]);
        exit;
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $vm_id = $params["customfields"]["vm_id"];
    $response = $api->beGetVm([
        "vm_id" => $vm_id,
        "snapshotlist" => true
    ]);
    if(!$response["status"]){
        return $response["message"];
    }
    $snapshotlist = $response["snapshotlist"] ?? [];
    if(count($snapshotlist) >= $snapcount){
        echo json_encode(["status" => false,"message" => "Maksimum yedek sayısına ulaştınız, lütfen bazı yedekleri siliniz!"]);
        exit;
    }
    $response = $api->beCreateSnapshot([
        "vm_id" => $vm_id
    ]);
    $response["refresh"] = 1;
    echo json_encode($response,JSON_UNESCAPED_UNICODE);
    exit;
}
function diyovm_snapshot_deploy($params){
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beDeploySnapshot([
        "vm_id" => $params["customfields"]["vm_id"],
        "ssid" => (int)$_POST["ssid"]
    ]);
    echo json_encode($response,JSON_UNESCAPED_UNICODE);
    exit;
}
function diyovm_snapshot_delete($params){
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beDeleteSnapshot([
        "vm_id" => $params["customfields"]["vm_id"],
        "ssid" => (int)$_POST["ssid"]
    ]);
    echo json_encode($response,JSON_UNESCAPED_UNICODE);
    exit;
}
function diyovm_menu_logs($params){
    $serviceid = (int)$params["serviceid"];
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beGetVm([
        "vm_id" => $params["customfields"]["vm_id"],
        "logs" => true,
    ]);
    if(!$response["status"]){
        return $response["message"];
    }
    $lang = $params["clientsdetails"]["language"];
    if(!$lang){
        $lang = "turkish";
    }
    if(!file_exists(__DIR__."/lang/".$lang.".php")){
        $lang = "turkish";
    }
    $lang = include(__DIR__."/lang/".$lang.".php");
    return [
        "tabOverviewReplacementTemplate" => "templates/logs.tpl",
        "vars" => [
            "lang" => $lang,
            "default_url" => $params["default_url"],
            "logs" => $response["logs"],
            "serviceid" => $serviceid
        ]
    ];
}
function diyovm_menu_format($params){
    $serviceid = (int)$params["serviceid"];
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beGetVm([
        "vm_id" => $params["customfields"]["vm_id"],
        "templatelist" => true,
    ]);
    if(!$response["status"]){
        echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
        exit;
    }
    $templatelist = $response["templatelist"];
    $pid = (int)$params["configoption5"];
    if($pid){
        $response = $api->beGetPlans([
            "pid" => $pid
        ]);
        if(!$response["status"]){
            return $response["message"];
        }
        $plan = $response["plans"][0];
        if($plan["ptemplates"] != "-1"){
            $ptemplates = explode(",",$plan["ptemplates"]);
            foreach($templatelist as $key => $template){
                if(!in_array($template["tid"],$ptemplates)){
                    unset($templatelist[$key]);
                }
            }
        }
    }
    $ptemplates = $params["configoption16"];
    if($ptemplates){
        $ptemplates = explode(",",$ptemplates);
        foreach($templatelist as $key => $template){
            if(!in_array($template["tid"],$ptemplates)){
                unset($templatelist[$key]);
            }
        }
    }
    $formatdeserve = (int)$params["configoption6"];
    if($params["customfields"]["formatdeserve"]){
        $formatdeserve = (int)$params["customfields"]["formatdeserve"];
    }
    $formatcount = (int)$params["model"]->serviceProperties->get("formatCount");
    $formatright = (int)($formatdeserve-$formatcount);
    if($formatright < 1){
        $formatright = 0;
    }
    $lang = $params["clientsdetails"]["language"];
    if(!$lang){
        $lang = "turkish";
    }
    if(!file_exists(__DIR__."/lang/".$lang.".php")){
        $lang = "turkish";
    }
    $lang = include(__DIR__."/lang/".$lang.".php");
    return [
        "tabOverviewReplacementTemplate" => "templates/format.tpl",
        "vars" => [
            "lang" => $lang,
            "default_url" => $params["default_url"],
            "formatdeserve" => $formatdeserve,
            "formatright" => $formatright,
            "templatelist" => $templatelist,
            "serviceid" => $serviceid
        ]
    ];
}
function diyovm_format($params){
    $serviceid = (int)$params["serviceid"];
    if($_POST["approval"] != 1){
        echo json_encode(["status" => false,"message" => "Lütfen tüm bilgilerinizin siliniceğini onaylayın!"]);
        exit;
    }
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $formatcount = (int)$params["model"]->serviceProperties->get("formatCount");
    $formatdeserve = (int)$params["configoption6"];
    $formattimefirst = (int)$params["model"]->serviceProperties->get("formatFirstTime");
    $timenow = time();
    if($formatdeserve > 0){
        if($formatcount >= $formatdeserve){
            if($timenow-$formattimefirst < 2592000){
                echo json_encode(["status" => false,"message" => "Bir ay içerisinde tüm format haklarınızı kullandınız tekrardan dolmasına: ".(round(($timenow-$formattimefirst+2592000)/86400))." gün kaldı!"],JSON_UNESCAPED_UNICODE);
                exit;
            }
            else{
                $params["model"]->serviceProperties->save(["formatCount" => 0,"formatFirstTime" => $timenow]);
            }
        }
        else{
            $updatedata = [];
            if(!$formattimefirst){
                $updatedata["formatFirstTime"] = $timenow;
            }
            $updatedata["formatCount"] = $formatcount+1;
            $updatedata["formatCountTotal"] = $formatdeserve;
            $params["model"]->serviceProperties->save($updatedata);
        }
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beGetTemplates([
        "tid" => 0
    ]);
    $templatelist = $response["templates"] ?? [];
    $pid = (int)$params["configoption5"];
    if($pid){
        $response = $api->beGetPlans([
            "pid" => $pid
        ]);
        if(!$response["status"]){
            return $response["message"];
        }
        $plan = $response["plans"][0];
        if($plan["ptemplates"] != "-1"){
            $ptemplates = explode(",",$plan["ptemplates"]);
            foreach($templatelist as $key => $template){
                if(!in_array($template["tid"],$ptemplates)){
                    unset($templatelist[$key]);
                }
            }
        }
    }
    $ptemplates = $params["configoption16"];
    if($ptemplates){
        $ptemplates = explode(",",$ptemplates);
        foreach($templatelist as $key => $template){
            if(!in_array($template["tid"],$ptemplates)){
                unset($templatelist[$key]);
            }
        }
    }
    $tid = (int)$_POST["template"];
    $passed = false;
    foreach($templatelist as $template){
        if($template["tid"] == $tid){
            $passed = true;
            break;
        }
    }
    if(!$passed){
        echo json_encode(["status" => false,"message" => "Bu işletim sistemi kullanabiliceğiniz işletim sistemleri arasında değil!"]);
        exit;
    }
    $params["model"]->serviceProperties->save(["status" => "1"]);
    $response = $api->beFormatVM([
        "vm_id" => $params["customfields"]["vm_id"],
        "template" => $tid,
        "password" => $_POST["password"]
    ]);
    $response["url"] = "clientarea.php?action=productdetails&id=".$serviceid;
    echo json_encode($response,JSON_UNESCAPED_UNICODE);
    exit;
}
function diyovm_format_step($params){
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beGetTask([
        "taskid" => $params["customfields"]["taskid"]
    ]);
    if(!$response["status"]){
        echo json_encode(["status" => false,"message" => $response["message"]]);
        exit;
    }
    $task = $response["task"];
    $laststep = (int)$_POST["laststep"];
    $steps = [
        0 => "Siliniyor!",
        1 => "Kurulum için hazırlanıyor!",
        2 => "Kurulum yapılıyor",
        3 => "Disk Ayarlanıyor",
        4 => "Sunucu Başlatılıyor",
        5 => "Ip adresleri tanımlanıyor!"
    ];
    if($task["tstatus"] == 0){
        $params["model"]->serviceProperties->save(["status" => "2"]);
        echo json_encode(["refresh" => 1]);
        exit;
    }
    $tdata = json_decode($task["tdata"],true);
    $stepnow = $tdata["status"]["step"];
    if($laststep == $stepnow){
        if($stepnow == 2){
            echo json_encode(["percent" => $tdata["vars"]["percent"]]);
            exit;
        }
        echo json_encode(["stepnow" => $stepnow]);
        exit;
    }
    $start = 1;
    if($stepnow == 14){
        $start = 0;
        $stepnow = 0;
    }
    $stepscontent = "";
    for($i = $start; $i < 6; $i++){
        if($stepnow > $i){
            $stepscontent .= "<li class=\"maked\"><span>{$steps[$i]}</span><i class=\"fa fa-check\"></i></li>";
        }
        else if($stepnow == $i){
            $activestep = $steps[$i];
            if($i == 2){
                $extradata = " <span class=\"percentServer\">%".$tdata["vars"]["percent"]."</span>";
            }
            $stepscontent .= "<li class=\"active\"><span>{$activestep}{$extradata}</span><i class=\"fa fa-refresh fa-spin\"></i></li>";
        }
        else{
            $stepscontent .= "<li class=\"waiting\"><span>{$steps[$i]}</span><i class=\"fa fa-close\"></i></li>";
        }
    }
    echo json_encode(["steps" => $stepscontent,"steptext" => $activestep,"stepnow" => $stepnow,"data" => $tdata]);
    exit;
}
function diyovm_format_trigger($params){
    $ch = curl_init();
    curl_setopt($ch,CURLOPT_URL,"https://{$params['serverhostname']}/app/tasks/createserver.php");
    curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,false);
    curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,false);
    curl_exec($ch);
    echo json_encode([
        "status" => 1
    ],JSON_UNESCAPED_UNICODE);
    curl_close($ch);
}
function diyovm_check_stat($params){
    $vmid = $params["customfields"]["vm_id"];
    $ch = curl_init();
    curl_setopt($ch,CURLOPT_URL,"https://{$params['serverhostname']}/app/tasks/statserver.php?vmlist={$vmid}");
    curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,false);
    curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,false);
    curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
    curl_exec($ch);
    curl_close($ch);
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beGetVm([
        "vm_id" => $vmid,
    ]);
    $vm = $response["server"];
    $vm["sdata"] = json_decode($vm["sdata"],true);
    $usageinfo = [
        "cpu_usage" => $vm["sdata"]["stats"]["cpu_mhz"],
        "cpu_max" => round($vm["sdata"]["settings"]["core"]*$vm["sdata"]["stats"]["cpu_hz"]*1000),
        "cpu_percent" => $vm["sdata"]["stats"]["cpu_percent"],
        "cpu_type" => "MHZ",
        "ram_usage" => $vm["sdata"]["stats"]["ram_mb"],
        "ram_max" => $vm["sdata"]["settings"]["ram"],
        "ram_percent" => $vm["sdata"]["stats"]["ram_percent"],
        "ram_type" => "MB",
        "disc_usage" => $vm["sdata"]["stats"]["disk_gb"],
        "disc_max" => $vm["sdata"]["settings"]["disk"],
        "disc_percent" => $vm["sdata"]["stats"]["disk_percent"],
        "network_usage" => $vm["sdata"]["stats"]["network"],
        "network_type" => "KB/sn"
    ];
    if($usageinfo["ram_usage"] > 1024){
        $usageinfo["ram_usage"] /= 1024;
        $usageinfo["ram_usage"] = round($usageinfo["ram_usage"],2);
        $usageinfo["ram_type"] = "GB";
    }
    if($usageinfo["cpu_usage"] > 1024){
        $usageinfo["cpu_usage"] /= 1000;
        $usageinfo["cpu_usage"] = round($usageinfo["cpu_usage"],2);
        $usageinfo["cpu_type"] = "GHZ";
    }
    if($usageinfo["cpu_percent"] > 60){
        $usageinfo["cpu_percent_color"] = "#f1416c";
    }
    else if($usageinfo["cpu_percent"] > 30){
        $usageinfo["cpu_percent_color"] = "#ffc700";
    }
    else{
        $usageinfo["cpu_percent_color"] = "#009ef7";
    }
    if($usageinfo["ram_percent"] > 60){
        $usageinfo["ram_percent_color"] = "#f1416c";
    }
    else if($usageinfo["ram_percent"] > 30){
        $usageinfo["ram_percent_color"] = "#ffc700";
    }
    else{
        $usageinfo["ram_percent_color"] = "#009ef7";
    }
    if($usageinfo["disk_percent"] > 60){
        $usageinfo["disc_percent_color"] = "#f1416c";
    }
    else if($usageinfo["disk_percent"] > 30){
        $usageinfo["disc_percent_color"] = "#ffc700";
    }
    else{
        $usageinfo["disc_percent_color"] = "#009ef7";
    }
    echo json_encode($usageinfo,JSON_UNESCAPED_UNICODE);
    exit;
}
function diyovm_ClientArea($params){
    $packageid = (int)$params["packageid"];
    $serviceid = (int)$params["serviceid"];
    $params["default_url"] = "clientarea.php?action=productdetails&id=".$serviceid;
    switch($_SERVER["REQUEST_METHOD"]){
        case "GET" :
            $menu = $_GET["bemenu"];
            if($menu){
                if(!in_array($menu,["password","console","ip","rdns","rdns_create","rdns_edit","snapshot","logs","format"])){
                    beError("Bulunamadı","Belirtilen menü sistem üzerinde bulunamadı!");
                }
                return call_user_func("diyovm_menu_".$menu,$params);
            }
            break;
        case "POST" :
            $method = $_POST["be_method"];
            if($method){
                if(!in_array($method,["power_action","entegration","password_change","format","snapshot_create","snapshot_deploy","snapshot_delete","rdns_create","rdns_edit","rdns_delete","check_stat","format_trigger","format_step"])){
                    echo json_encode(["status" => false,"message" => "Belirtilen menü sistem üzerinde bulunamadı!"],JSON_UNESCAPED_UNICODE);
                    exit;
                }
                call_user_func("diyovm_".$method,$params);
            }
            break;
    }
    if(!class_exists("beDiyoApi")){
        require __DIR__."/be_system.php";
    }
    $api = new beDiyoApi();
    $api->beSetServer([
        "name" => $params["serverhostname"],
        "username" => $params["serverusername"],
        "password" => $params["serverpassword"],
        "access_hash" => $params["serveraccesshash"]
    ]);
    $response = $api->beGetVm([
        "vm_id" => $params["customfields"]["vm_id"],
        "templatelist" => true
    ]);
    if(!$response["status"]){
        return $response["message"];
    }
    $vm = $response["server"];
    $vm["sdata"] = json_decode($vm["sdata"],true);
    $templatelist = $response["templatelist"] ?? [];
    if($vm["sdata"]["formatting"] != 0){
        $params["model"]->serviceProperties->save([
            "taskid" => $vm["sdata"]["formatting"],
            "status" => "1"
        ]);
        $page = [
            "tabOverviewReplacementTemplate" => "templates/formatarea.tpl",
            "vars" => [
                "customfields" => $params["customfields"],
                "vm" => $vm,
                "serviceid" => $serviceid
            ]
        ];
        return $page;
        exit;
    }
    else{
        $params["model"]->serviceProperties->save(["status" => "2"]);
    }
    foreach($templatelist as $template){
        if($vm["sdata"]["template"] == $template["tid"]){
            $vm["sdata"]["templatename"] = $template["tname"];
        }
    }
    $orderinfo = [
        "product" => $params["model"]->product->name,
        "billingcycle" => $params["templatevars"]["billingcycle"],
        "regdate" => date("d.m.Y",strtotime($params["templatevars"]["regdate"])),
        "nextduedate" => $params["templatevars"]["nextduedate"] ? date("d.m.Y",strtotime($params["templatevars"]["nextduedate"])):"--",
        "amount" => $params["templatevars"]["recurringamount"]->toFull(),
        "paymethod" => $params["templatevars"]["paymentmethod"]
    ];
    if(!$vm["sdata"]["stats"]["uptime"]){
        $vm["sdata"]["stats"]["uptime"] = 0;
    }
    if(!$vm["slastcheck"]){
        $vm["slastcheck"] = 0;
    }
    $vminfo = [
        "power" => $vm["sdata"]["stats"]["power_status"],
        "uptime" => round($vm["sdata"]["stats"]["uptime"]/60),
        "lastcheck" => round((time()-$vm["slastcheck"])/60),
        "templatename" => $vm["sdata"]["templatename"],
        "ipaddres" => $vm["sip"],
        "username" => $vm["sdata"]["config"]["username"],
        "password" => $vm["sdata"]["config"]["password"]
    ];
    $usageinfo = [
        "cpu_usage" => $vm["sdata"]["stats"]["cpu_mhz"],
        "cpu_max" => round($vm["sdata"]["settings"]["core"]*$vm["sdata"]["stats"]["cpu_hz"]*1000),
        "cpu_percent" => $vm["sdata"]["stats"]["cpu_percent"],
        "cpu_type" => "MHZ",
        "ram_usage" => $vm["sdata"]["stats"]["ram_mb"],
        "ram_max" => $vm["sdata"]["settings"]["ram"],
        "ram_percent" => $vm["sdata"]["stats"]["ram_percent"],
        "ram_type" => "MB",
        "disk_usage" => $vm["sdata"]["stats"]["disk_gb"],
        "disk_max" => $vm["sdata"]["settings"]["disk"],
        "disk_percent" => $vm["sdata"]["stats"]["disk_percent"],
        "network_usage" => $vm["sdata"]["stats"]["network"],
        "network_type" => "KB/sn"
    ];
    if($usageinfo["ram_usage"] > 1024){
        $usageinfo["ram_usage"] /= 1024;
        $usageinfo["ram_usage"] = round($usageinfo["ram_usage"],2);
        $usageinfo["ram_type"] = "GB";
    }
    if($usageinfo["cpu_usage"] > 1024){
        $usageinfo["cpu_usage"] /= 1000;
        $usageinfo["cpu_usage"] = round($usageinfo["cpu_usage"],2);
        $usageinfo["cpu_type"] = "GHZ";
    }
    if($usageinfo["network_usage"] > 128){
		$usageinfo["network_usage"] = round($usageinfo["network_usage"]/128);
        $usageinfo["network_type"] = "MB/sn";
    }
    $lang = $params["clientsdetails"]["language"];
    if(!$lang){
        $lang = "turkish";
    }
    if(!file_exists(__DIR__."/lang/".$lang.".php")){
        $lang = "turkish";
    }
    $lang = include(__DIR__."/lang/".$lang.".php");
    $page = [
        "tabOverviewReplacementTemplate" => "templates/index.tpl",
        "vars" => [
            "lang" => $lang,
            "default_url" => $params["default_url"],
            "customfields" => $params["customfields"],
            "orderinfo" => $orderinfo,
            "vminfo" => $vminfo,
            "usageinfo" => $usageinfo,
            "packageid" => $packageid,
            "serviceid" => $serviceid
        ]
    ];
    return $page;
}
function beError($name,$message){
    echo $message;
    exit;
}
?>